#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d9.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d9.h>

#include "oxdebugfont.h"


TCHAR gName[100] = _T("fobO\eXg");

// EBhEvV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam){
        if(mes == WM_DESTROY || mes == WM_CLOSE ) {PostQuitMessage(0); return 0;}
   return DefWindowProc(hWnd, mes, wParam, lParam);
}


int APIENTRY _tWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
   // AvP[V̏
   MSG msg; HWND hWnd;
   WNDCLASSEX wcex ={sizeof(WNDCLASSEX), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
                                    (HBRUSH)(COLOR_WINDOW+1), NULL, (TCHAR*)gName, NULL};
   if(!RegisterClassEx(&wcex))
      return 0;

   RECT r = {0, 0, 640, 480};
   ::AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
   if(!(hWnd = CreateWindow(gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, r.right - r.left, r.bottom - r.top,
                                    NULL, NULL, hInstance, NULL)))
      return 0;

   // Direct3D̏
   LPDIRECT3D9 g_pD3D;
   LPDIRECT3DDEVICE9 g_pD3DDev;
   if( !(g_pD3D = Direct3DCreate9( D3D_SDK_VERSION )) ) return 0;

   D3DPRESENT_PARAMETERS d3dpp = {640,480,D3DFMT_UNKNOWN,0,D3DMULTISAMPLE_NONE,0,
                                                      D3DSWAPEFFECT_DISCARD,NULL,TRUE,0,D3DFMT_UNKNOWN,0,0}; 
   d3dpp.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;

   if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd, D3DCREATE_HARDWARE_VERTEXPROCESSING, &d3dpp, &g_pD3DDev ) ) ) {
      g_pD3D->Release();
      return 0;
   }

   // 
   //  [vOɈxĂяo܂B
   OX::DebugFont::initialize(g_pD3DDev, 2500, 1024);


   ShowWindow(hWnd, nCmdShow);

	int count = 0;
	// bZ[W [v
	do{
		if( PeekMessage(&msg, NULL, 0, 0, PM_REMOVE) ){
			DispatchMessage(&msg);
		}

		// Direct3D̏
		count++;
		g_pD3DDev->Clear( 0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,96), 1.0f, 0 );
		g_pD3DDev->BeginScene();

		// fobO\
		//  O[oȃNXȂ̂łǂłĂׂ܂I
		OX::DebugFont::print(50, 100, 0xff00ffff, "OX TUKURO- : http://marupeke296.com", count);
		OX::DebugFont::print(70, 130, 0xffffffff, "This is a test of debug texts. Counter = %d. Pi = %f", count, 3.141592f);

		// g\
		OX::DebugFont::Option option;
		option.clip = true;
		option.clipWidth = 120;

		// E
		option.align = OX::DebugFont::Option::RIGHT;
		OX::DebugFont::print(70, 150, 0xffffff00, option, "Clipping and Alignment: w = %d, Right alignment.", option.clipWidth);

		// 
		option.align = OX::DebugFont::Option::LEFT;
		OX::DebugFont::print(70, 220, 0xffffff00, option, "Clipping and Alignment: w = %d, Left alignment.", option.clipWidth);

		// 
		option.align = OX::DebugFont::Option::CENTER;
		OX::DebugFont::print(70, 290, 0xffffff00, option, "Clipping and Alignment: w = %d, Center alignment.", option.clipWidth);


		// `
		OX::DebugFont::draw(g_pD3DDev);

		g_pD3DDev->EndScene();
		g_pD3DDev->Present( NULL, NULL, NULL, NULL );

		// obt@ʒuNA
		// NAȂƂĕǉłȂȂ܂iI[o[͂܂j
		OX::DebugFont::clear();
	}while(msg.message != WM_QUIT);

	// I
	//  DebugFont̃fXgN^łĂ΂܂AɌĂłmł
	OX::DebugFont::terminate();

	g_pD3DDev->Release();
	g_pD3D->Release();

	return 0;
}